//
//      PlayMedia.c
//

#include "AEEModGen.h"          // W[ C^[tFCX
#include "AEEAppGen.h"          // Avbg C^[tFCX
#include "AEEShell.h"           // VF C^[tFCX
#include "AEEStdLib.h"          // wp[֐
#include "AEEMediaFormats.h"    // fBA C^[tFCX
#include "AEEMediaUtil.h"       // IMediaUtil C^[tFCX
#include "AEEFile.h"            // t@C C^[tFCX

#include "PlayMedia.bid"        // ClassID


// Avbg\
typedef struct _PlayMedia {
    AEEApplet       a;          // ŏ̃o͕K AEEApplet ɂ邱
    IMedia*         media;      // IMedia hC^[tFCX
    AEEMediaData    mdata;      // fBA f[^
} PlayMedia;


// O錾
static boolean PlayMedia_HandleEvent(PlayMedia * pi, AEEEvent eCode, 
                                      uint16 wParam, uint32 dwParam);

static boolean PlayMedia_OnAppStart(PlayMedia* app);
static boolean PlayMedia_OnAppStop(PlayMedia* app);
static boolean PlayMedia_OnKeyPress(PlayMedia* app, uint16 key);

static void PlayMedia_PlaySound1(PlayMedia* app);
static void PlayMedia_PlaySound2(PlayMedia* app);
static void PlayMedia_PlaySound3(PlayMedia* app);


//
//  Avbg쐬ƂɌĂяo
//
int AEEClsCreateInstance(AEECLSID ClsId, IShell * pIShell, IModule * po, void ** ppObj)
{
    *ppObj = NULL;
    
    if (ClsId == AEECLSID_PLAYMEDIA) {
        if (AEEApplet_New(sizeof(PlayMedia), ClsId, pIShell, po, (IApplet**)ppObj,
            (AEEHANDLER)PlayMedia_HandleEvent, NULL)
            == TRUE)
        {
            // Avbg\̂̏
            PlayMedia* app = (PlayMedia*)(*ppObj);
            app->media = NULL;
            app->mdata.pData = NULL;
            
            return (AEE_SUCCESS);
        }
    }
    return (EFAILED);
}


//
//  Cxg nh
//
static boolean PlayMedia_HandleEvent(PlayMedia * app, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{  
    switch (eCode) 
    {
    case EVT_APP_START:                        
        return PlayMedia_OnAppStart(app);

    case EVT_APP_STOP:
        return PlayMedia_OnAppStop(app);

    case EVT_KEY_PRESS:
        return PlayMedia_OnKeyPress(app, wParam);
    }
    return FALSE;
}


//
//  AvJnCxg
//
static boolean PlayMedia_OnAppStart(PlayMedia* app)
{
    IShell* shell   = app->a.m_pIShell;
    IDisplay* disp  = app->a.m_pIDisplay;
    AEERect rect;
    AEEDeviceInfo devinfo;

    // ʑŜ̃TCY擾
    ISHELL_GetDeviceInfo(shell, &devinfo);
    rect.x = 0;
    rect.y = 0;
    rect.dx = devinfo.cxScreen;
    rect.dy = devinfo.cyScreen;

    // ʂNAĂ
    IDISPLAY_FillRect(disp, &rect, MAKE_RGB(255,255,255));

    // ʍXV
    IDISPLAY_Update(disp);

    // TEhĐ (ꂩP̌ĂяoIĂ)
    PlayMedia_PlaySound1(app);
    //PlayMedia_PlaySound2(app);
    //PlayMedia_PlaySound3(app);

    return TRUE;
}


//
//  AvICxg
//
static boolean PlayMedia_OnAppStop(PlayMedia* app)
{
    // IMedia hC^[tFCX̉
    if (app->media != NULL) {
        IMEDIA_Release(app->media);
    }

    // fBA f[^̉
    if (app->mdata.pData != NULL) {
        FREE(app->mdata.pData);            
    }

    return TRUE;
}


//
//  L[Cxg
//
static boolean PlayMedia_OnKeyPress(PlayMedia* app, uint16 key)
{
    if (key == AVK_SELECT) {
        if (app->media != NULL) {
            boolean bStateChanging;
            int state;

            state = IMEDIA_GetState(app->media, &bStateChanging);
            if (state == MM_STATE_PLAY) {
                IMEDIA_Stop(app->media);
            }
            else {
                IMEDIA_Play(app->media);
            }
        }
        return TRUE;
    }

    return FALSE;
}


//
//  IMediaUtil C^[tFCXgpāA
//  MIDI t@CĐ܂B
//
static void PlayMedia_PlaySound1(PlayMedia* app)
{
    IShell* shell   = app->a.m_pIShell;
    IMediaUtil* mutil = NULL;
    const char* filename = "test.mid";

    ISHELL_CreateInstance(shell, AEECLSID_MEDIAUTIL, (void**) &mutil);
    if (mutil != NULL) {
        app->mdata.clsData  = MMD_FILE_NAME;
        app->mdata.pData    = STRDUP(filename);
        app->mdata.dwSize   = 0;

        IMEDIAUTIL_CreateMedia(mutil, &app->mdata, &app->media);
    }
    IMEDIAUTIL_Release(mutil);

    if (app->media != NULL) {
        IMEDIA_Play(app->media);
    }
}


//
//  IMediaMIDI C^[tFCX쐬āA
//  MIDI t@CĐ܂B
//
static void PlayMedia_PlaySound2(PlayMedia* app)
{
    IShell* shell   = app->a.m_pIShell;
    const char* filename = "test.mid";

    // IMediaMIDI C^[tFCX擾āAĐf[^ZbgB
    ISHELL_CreateInstance(shell, AEECLSID_MEDIAMIDI, (void**) &app->media);
    if (app->media != NULL) {
        app->mdata.clsData  = MMD_FILE_NAME;
        app->mdata.pData    = STRDUP(filename);
        app->mdata.dwSize   = 0;

        IMEDIA_SetMediaData(app->media, &app->mdata);
        IMEDIA_Play(app->media);
    }
}


//
//  t@CƎ MIDI f[^ǂݎA
//  IMediaMIDI C^[tFCX쐬čĐ܂B
//
static void PlayMedia_PlaySound3(PlayMedia* app)
{
    IShell* shell   = app->a.m_pIShell;
    IFileMgr* filemgr;
    IFile* file;
    uint32 filesize;
    const char* filename = "test.mid";
    FileInfo fileinfo;

    // t@CJ
    ISHELL_CreateInstance(shell, AEECLSID_FILEMGR, &filemgr);
    file = IFILEMGR_OpenFile(filemgr, filename, _OFM_READ);
    if (file == NULL) {
        IFILEMGR_Release(filemgr);
        return;
    }

    // t@C TCY擾
    IFILEMGR_GetInfo(filemgr, filename, &fileinfo);
    filesize = fileinfo.dwSize;
    
    // obt@mۂ
    app->mdata.pData = (byte*) MALLOC(filesize);

    // f[^obt@ɓǂݎ
    IFILE_Read(file, app->mdata.pData, filesize);

    // t@C̉
    IFILE_Release(file);
    IFILEMGR_Release(filemgr);

    // fBA f[^
    app->mdata.clsData = MMD_BUFFER;
    app->mdata.dwSize = filesize;
    
    // IMediaMIDI C^[tFCX쐬āAĐB
    ISHELL_CreateInstance(shell, AEECLSID_MEDIAMIDI, &app->media);
    if (app->media != NULL) {
        IMEDIA_SetMediaData(app->media, &app->mdata);
        IMEDIA_Play(app->media);
    }
}


